/*
 * Copyright (c) 2007 Nuova Systems, Inc.  All rights reserved.
 */
#ifndef __ASM_MACH_PALO_MEMSYNC_H
#define __ASM_MACH_PALO_MEMSYNC_H

#include <common/include/memsync_mregs.h>

// For mipssim, memsync doesn't do anything, so we need to sync.
#ifdef MIPSSIM
#define sync()                  asm volatile("sync" ::: "memory")
#define ehb()                   asm volatile("ehb" ::: "memory")
#define memory_barrier()        do { sync(); ehb(); } while (0)
#else // MIPSSIM
#define sync()
#define ehb()
#define memory_barrier()        asm volatile("" ::: "memory")
#endif // MIPSSIM

static void inline
palo_memsync(void)
{
	// First, memory barrier so compiler issues all stores to memory.
	memory_barrier();
	// Then poke memsync reg so Palo will wait for memory stores to land.
	writel(0, (u_int32_t *)KSEG1ADDR(MEMSYNC_MREGS_SYNC));
}

#endif /* __ASM_MACH_PALO_MEMSYNC_H */

