/*
 * Copyright 2012 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: rc.h 43 2016-12-03 22:59:19Z buildsa $"
#ifndef __RC_GLOBAL_H
#define __RC_GLOBAL_H

#include <linux/notifier.h>
#include <linux/types.h>
#include <linux/wait.h>
#include <common/libtps/include/queue.h>


#define PALOMEM_RC_SIZE 0x04000000
#define PALOMEM_RC_BASE 0x10000000

struct rc_event;
struct file;
struct pci_dev;


extern struct atomic_notifier_head rc_notify_list;
int register_rc_event_notifier(struct notifier_block *nb);

struct rc_notifier_param {
	u16 bdf;
	u8 ind_cause;
	u8 ecc_cause;
	u8 ecc_status;
};

struct acl_tcam {
	u16 vnic_offset;
	u16 hostid;
	u8 addr_space;
	u64 upstream_addr;
};

struct acl_ram {
	u8 action;
	u8 vnic_ovr;
	u8 vnic_ovr_en;
	u64 addr_ovr;
	u8 addr_ovr_en;
	u8 addr_space;
	u8 addr_size;
	u8 ecc;
};

struct rc_info {
	atomic_t refcnt;
	wait_queue_head_t waitq;
	spinlock_t events_lock;
	atomic_t nevents;
	TAILQ_HEAD(, rc_event) events;
};

extern struct rc_info rc_dev_info;
int rc_have_events(void);
void __devinit rc_evt_init(void);
int rc_copy_events_to_user(struct rc_event __user *uev);
void rc_evt_ind(int bdf, char cause);
void rc_evt_ecc(int ecc_cause, int ecc_status);
long rc_ioctl(struct file *filep, unsigned int cmd, unsigned long arg);
int update_lbdf2vnic_ram(struct pci_dev *dev, char addr_modifier,
	char action, char addr_space, char hiwidth);
void cleanup_lbdf2vnic_ram(struct pci_dev *dev);
int rc_acl_update(struct acl_tcam tcam, struct acl_ram ram);
void rc_acl_clear(int index);
int acl_info_show(char *buf);
int rc_copy_events_to_user(struct rc_event __user *uev);

#endif
