/*
 * Copyright 2010 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: regio.h 80134 2011-06-20 17:03:06Z brasmit2 $"

#ifndef _PALO_REGIO_H_
#define _PALO_REGIO_H_

static inline u_int32_t
readreg(u_int32_t pa)
{
	return readl((u_int32_t *)CKSEG1ADDR(pa));
}

static inline u_int64_t
readreg64(u_int32_t pa)
{
	return readreg(pa) | (((u_int64_t)readreg(pa + 4)) << 32);
}

static inline void
readregs(u_int32_t pa, u_int32_t *val, u_int32_t ndw)
{
	while (ndw-- > 0) {

		*val = readreg(pa);

		pa += sizeof (u_int32_t);
		val++;
	}
}

static inline void
writereg(u_int32_t pa, u_int32_t val)
{
	writel(val, (void *)CKSEG1ADDR(pa));
}

static inline void
writereg64(u_int32_t pa, u_int64_t val)
{
	writereg(pa, (u_int32_t)val);
	writereg(pa + 4, (u_int32_t)(val >> 32));
}

static inline void
writeregs(u_int32_t pa, u_int32_t *val, u_int32_t ndw)
{
	while (ndw-- > 0) {

		writereg(pa, *val);

		pa += sizeof (u_int32_t);
		val++;
	}
}

#endif /* _PALO_REGIO_H_ */
