/*
 * Copyright 2012 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: fixup-rc.c 43 2016-12-03 22:59:19Z buildsa $"
#include <linux/pci.h>
#include <asm/mach-palo/paloint.h>

#include "rc.h"
#include "ecpu_res.h"

int __init pcibios_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
{
	return palo_int_to_irq(RC_DEVICE_LEGACY_INT_LVL,
			RC_DEVICE_LEGACY_INT_BASE);
}

/* Do platform specific device initialization at pci_enable_device() time */
int pcibios_plat_dev_init(struct pci_dev *dev)
{
	unsigned int intr_address = 0;
	char mem_space = 1;
	char action = 0; // Direct addressing
	int reg;
	extern int rc_pcie_hotplug_supported;

	pcie_set_readrq(dev, 256);
	pcie_set_payload(dev, 256);
	if (dev->hdr_type == PCI_HEADER_TYPE_NORMAL)
		setup_rcvnic_reg(dev, intr_address, mem_space, action, NULL);

	if ((dev->hdr_type == PCI_HEADER_TYPE_BRIDGE) && pci_is_pcie(dev) &&
	    rc_pcie_hotplug_supported) {
		pci_read_config_dword(dev,
				pci_pcie_cap(dev) + PCI_EXP_SLTCAP, &reg);
		if (reg & PCI_EXP_SLTCAP_HPC)
			setup_rcvnic_reg(dev,
					intr_address, mem_space, action, NULL);
	}
	return 0;
}

void pcibios_plat_dev_deinit(struct pci_dev *dev)
{
	release_rcvnic_reg(dev);
}
