/*
 * Copyright 2007 Nuova Systems, Inc.  All rights reserved.
 * Copyright 2009-2015 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: ppcie.h 144815 2013-09-22 21:59:07Z sborikar $"

#ifndef _PPCIE_H_
#define _PPCIE_H_

#include <palo/include/pcie_mregs.h>
#include <palo/include/misc_regs.h>

#include <common/libtps/include/queue.h>
#include <palo/fw/mcpu/include/ppcie_dev.h>
#include "pciemgr.h"

#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

struct ppcie_device_info {
    atomic_t refcnt;
    wait_queue_head_t waitq;
    spinlock_t events_lock;
    atomic_t nevents;
    TAILQ_HEAD(, ppcie_event) events;
};
extern struct ppcie_device_info ppcie_device_info;

struct platform_device;
void    ppcie_host_init(void);
int     ppcie_intr_init(struct platform_device *dev);
int     ppcie_intr_reset(void);
long    ppcie_ioctl(struct file *filp, unsigned int cmd, unsigned long arg);
int     ppcie_vnic_load(pmvnich_t pmvnich);
int     ppcie_vnic_unload(pmvnich_t pmvnich);

#define DRV_NAME "palopcie"
#define DRV_DESCRIPTION "Driver for Palo PCIe"
#define DRV_VERSION "2.0"
#define DRV_COPYRIGHT "Copyright 2007-2015 Cisco Systems, Inc"
#define PFX DRV_NAME ": "

#endif /* _PPCIE_H_ */
