/*
 * Copyright 2012 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: ppcie_host.h 144815 2013-09-22 21:59:07Z sborikar $"

#ifndef _PPCIE_HOST_H_
#define _PPCIE_HOST_H_

#define PCIE_LINKF_NONE         0x0
#define PCIE_LINKF_TX_FLIP      0x1     /* flip tx lanes */
#define PCIE_LINKF_RX_FLIP      0x2     /* flip rx lanes */

void ppcie_host_init(void);
hostid_t ppcie_hostid_max(void);
u_int8_t ppcie_hostid_hid(const hostid_t hostid);
u_int8_t ppcie_hostid_shid(const hostid_t hostid);
u_int8_t ppcie_hostid_pp(const hostid_t hostid);
u_int8_t ppcie_hostid_pps(const hostid_t hostid);
u_int8_t ppcie_hid_pp(const hid_t hid);
u_int8_t ppcie_hid_pps(const hid_t hid);

void ppcie_get_linkparams(const hid_t hid, u32 *width, u32 *flags);
void ppcie_set_linkparams(const hid_t hid, const u32 width, const u32 flags);
hostid_t ppcie_hostid_make(const hid_t hid, const shid_t shid);
u_int8_t ppcie_hostid_reqidx(const hostid_t hostid);
hostid_t ppcie_reqidx_hostid(const u_int8_t reqidx);

struct ppcie_hostinfo;
int ppcie_hostid_get_hostinfo(struct ppcie_hostinfo *ppciehi);

typedef void (*ppcie_hostcb_t)(u_int32_t id, void *cbarg);

void ppcie_foreach_hid(ppcie_hostcb_t cb, void *cbarg);

#endif /* _PPCIE_HOST_H_ */
