/*
 * Copyright (c) 2013 Cisco Systems, Inc.  All rights reserved.
 */
#ifndef _BURST_WRITE_H
#define _BURST_WRITE_H

#define BURST_CONTEXT_COUNT 4

#define BURST_CONTEXT0_OFFSET 0
#define BURST_CONTEXT1_OFFSET 64
#define BURST_CONTEXT2_OFFSET 128
#define BURST_CONTEXT3_OFFSET 192

#define BURST_CONTEXT_SIZE   64

/*
 * use context 3 as default
 */
#define BURST_CONTEXT_DEFAULT 3

#define BURST_WRITE_ERR_SIZE       (-1)
#define BURST_WRITE_ERR_ALIGN      (-2)
#define BURST_WRITE_ERR_ALIGN_XFER (-3)
#define BURST_WRITE_ERR_CTX_NO     (-4)

int burst_write_buffer(void *src_va, u_int64_t dst_pa,
                       u_int32_t length, int ctx_no);
#ifdef	CONFIG_BASE_PALO
#define burst_writeregs writeregs
#define burst_writereg64 writereg64
#else
int burst_writeregs(u_int32_t dst_pa, void *src_va, u_int32_t ndw);
int burst_writereg64(u_int32_t dst_pa, u_int64_t v64);
#endif

#endif /* _BURST_WRITE_H */
