
/*
 * Copyright 2012 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: palo_i2c_defs.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _PALO_I2C_DEFS_H_
#define _PALO_I2C_DEFS_H_

/*
 * Definition of the I2C log file kept in the kernel.
 */
typedef struct {
    u_int64_t   jiffies;                // timestamp in jiffies
    u_int32_t   cycles;                 // timestamp in cycles (mips c0_count)
    u_int32_t   seq;                    // sequence number
    u_int8_t    target;                 // target device
    int8_t      ret;                    // return status
    u_int8_t    nmsgs;                  // number of messages
    u_int8_t    op;                     // operation (read/write)
    u_int8_t    adlen;                  // address length
    u_int8_t    addr[4];                // address
    u_int8_t    dalen;                  // data length
    u_int8_t    data[32];               // data
} palo_i2c_logent_t;
#define PALO_I2C_OP_READ    0
#define PALO_I2C_OP_WRITE   1

/*
 * I2C status codes within the paloi2c driver.
 */
enum { 
    PALO_I2C_ERR_NONE           =  0,
    PALO_I2C_ERR_TIMEOUT        = -1,
    PALO_I2C_ERR_MAXTRIES       = -2,
    PALO_I2C_ERR_TX_ABORT       = -3,
    PALO_I2C_ERR_RX_OVER        = -4,
    PALO_I2C_ERR_TX_SPLIT_START = -5,
    PALO_I2C_ERR_TX_SPLIT_STOP  = -6,
};

#endif
