/*
 * Copyright 2010 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: palonic.h 43 2016-12-03 22:59:19Z buildsa $"

#ifndef _PALONIC_H_
#define _PALONIC_H_

//  A palo nic request specifies the resources associated with
//  enic in the palo mcpu.
//
//  PALONIC_IOC_ADD
//      Add a new nic.
//  PALONIC_IOC_REMOVE
//      Remove the nic.

#define PALONIC_IOC            'N'
#define PALONIC_IOC_ADD        _IOW(PALONIC_IOC, 0, struct palo_nic)
#define PALONIC_IOC_REMOVE     _IOW(PALONIC_IOC, 1, u_int8_t)

#define DEVICE_NAME_LEN         16

#define PALONIC_F_NO_SHARE_INTR     0x0
#define PALONIC_F_SHARE_INTR        0x1

struct resource_info {
    u_int16_t wq_base;
    u_int16_t wq_size;
    u_int16_t rq_base;
    u_int16_t rq_size;
    u_int16_t cq_base;
    u_int16_t cq_size;
    u_int16_t in_base;
    u_int16_t in_size;
    u_int16_t lif_id;
    u_int16_t vnic_id;
};

struct palo_nic {
    char dev_name[DEVICE_NAME_LEN];
    u_int16_t mtu;
    struct resource_info resources;
    u_int8_t flags;
};

#endif /* _PALONIC_H_ */
