/*
 * Copyright 2006 Nuova Systems, Inc. All Rights Reserved
 * Copyright 2010-2011 Cisco Systems, Inc. All Rights Reserved
 */
#ident "$Id: net_regs.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _NET_REGS_H_
#define _NET_REGS_H_

#include "net_hregs.h"
#include "net_mregs.h"
#include "net_regs_defs.h"

#if defined CONFIG_BASE_PALO

//
// net_hregs.h has MAXCNT=512, BLKSZ=16...redefine these to match
// the LIF indexing into the RSS key array (128 LIFs, 64B per LIF)
//

#undef NET_HREGS_DHS_RSS_KEY_MAXCNT
#define NET_HREGS_DHS_RSS_KEY_MAXCNT      128
#undef NET_HREGS_DHS_RSS_KEY_BLKSZ
#define NET_HREGS_DHS_RSS_KEY_BLKSZ       64

//
// net_hregs.h has MAXCNT=4096, BLKSZ=8...redefine these to match
// the LIF indexing into the RSS cpu array (128 LIFs, 256B per LIF)
//

#undef NET_HREGS_DHS_RSS_CPU_MAXCNT
#define NET_HREGS_DHS_RSS_CPU_MAXCNT      128
#undef NET_HREGS_DHS_RSS_CPU_BLKSZ
#define NET_HREGS_DHS_RSS_CPU_BLKSZ       256

#elif defined CONFIG_BASE_SERENO

// See the Palo clause above for why these are redefined.

#undef NET_HREGS_DHS_RSS_KEY_MAXCNT
#define NET_HREGS_DHS_RSS_KEY_MAXCNT       256
#undef NET_HREGS_DHS_RSS_KEY_BLKSZ
#define NET_HREGS_DHS_RSS_KEY_BLKSZ        64

#undef NET_HREGS_DHS_RSS_CPU_MAXCNT
#define NET_HREGS_DHS_RSS_CPU_MAXCNT       256
#undef NET_HREGS_DHS_RSS_CPU_BLKSZ
#define NET_HREGS_DHS_RSS_CPU_BLKSZ        256

#elif defined CONFIG_BASE_CRUZ

// See the Palo clause above for why these are redefined.

#undef NET_HREGS_DHS_RSS_KEY_MAXCNT
#define NET_HREGS_DHS_RSS_KEY_MAXCNT       2048
#undef NET_HREGS_DHS_RSS_KEY_BLKSZ
#define NET_HREGS_DHS_RSS_KEY_BLKSZ        64

#undef NET_HREGS_DHS_RSS_CPU_MAXCNT
#define NET_HREGS_DHS_RSS_CPU_MAXCNT       2048
#undef NET_HREGS_DHS_RSS_CPU_BLKSZ
#define NET_HREGS_DHS_RSS_CPU_BLKSZ        256

#endif /* CONFIG_BASE */

#undef NET_HREGS_DHS_RSS_KEY_ADDR_COMPUTE
#define NET_HREGS_DHS_RSS_KEY_ADDR_COMPUTE(_base,_index,_offset) (((u_int32_t *)(_base)) + (NET_HREGS_DHS_RSS_KEY_OFFSET >> 2)+ ((_index)*(NET_HREGS_DHS_RSS_KEY_BLKSZ >> 2))+ (_offset))

#define NET_MREGS_DHS_CPUIF_FWD_TCAM_OFFSET(reg) \
  (NET_MREGS_DHS_CPUIF_FWD_TCAM_##reg##_OFFSET - \
  NET_MREGS_DHS_CPUIF_FWD_TCAM_OP_OFFSET)
#define NET_MREGS_CFG_CPUIF_FWD_TCAM_OFFSET(reg) \
  (NET_MREGS_CFG_CPUIF_FWD_TCAM_##reg##_OFFSET - \
  NET_MREGS_DHS_CPUIF_FWD_TCAM_OP_OFFSET)
#define NET_MREGS_STA_CPUIF_FWD_TCAM_OFFSET(reg) \
  (NET_MREGS_STA_CPUIF_FWD_TCAM_##reg##_OFFSET - \
  NET_MREGS_DHS_CPUIF_FWD_TCAM_OP_OFFSET)
#define NET_MREGS_CFG_UIF_OFFSET(reg) \
  (NET_MREGS_CFG_##reg##_OFFSET - \
  NET_MREGS_CFG_UIF0_CFG_OFFSET)
#define NET_MREGS_CFG_UIF_SEARCH_OFFSET(reg) \
  (NET_MREGS_CFG_##reg##_SEARCH_OFFSET - \
  NET_MREGS_CFG_UIF0_SEARCH_OFFSET)

#endif /* _NET_REGS_H_ */
