/*
 * Copyright 2006 Nuova Systems, Inc. All Rights Reserved
 * Copyright 2009 Cisco Systems, Inc. All Rights Reserved
 */
#ident "$Id: rq_regs.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _RQ_REGS_H_
#define _RQ_REGS_H_

#include "rq_hregs.h"
#include "rq_mregs.h"
#include "ig_mregs_gbl.h"
#include "rq_regs_defs.h"

#undef RQ_HREGS_BLKSZ
#define RQ_HREGS_BASE   RQ_HREGS_RING_BASE
#define RQ_HREGS_MAXCNT RQ_HREGS_RING_BASE_MAXCNT
#define RQ_HREGS_BLKSZ  RQ_HREGS_RING_BASE_BLKSZ

#undef RQ_MREGS_BLKSZ
#define RQ_MREGS_BASE   RQ_MREGS_MASTER_ENABLE
#define RQ_MREGS_MAXCNT RQ_MREGS_MASTER_ENABLE_MAXCNT
#define RQ_MREGS_BLKSZ  RQ_MREGS_MASTER_ENABLE_BLKSZ

#define RQ_HREGS_OFFSET(reg) \
  (RQ_HREGS_##reg##_OFFSET - RQ_HREGS_RING_BASE_OFFSET)
#define RQ_MREGS_OFFSET(reg) \
  (RQ_MREGS_##reg##_OFFSET - RQ_MREGS_MASTER_ENABLE_OFFSET)

#ifdef CONFIG_BASE_PALO
#include "rq_mregs_vnic.h"

#define RQ_MREGS_VNIC_BASE__    RQ_MREGS_VNIC_LOCAL_DMA_BASE
#define RQ_MREGS_VNIC_MAXCNT__  RQ_MREGS_VNIC_LOCAL_DMA_BASE_MAXCNT
#define RQ_MREGS_VNIC_BLKSZ__   RQ_MREGS_VNIC_LOCAL_DMA_BASE_BLKSZ

#define RQ_MREGS_VNIC_OFFSET_GEN(reg) \
  (RQ_MREGS_VNIC_##reg##_OFFSET - RQ_MREGS_VNIC_LOCAL_DMA_BASE_OFFSET)

#define RQ_CACHE_BASE_SIZE  (512 * 1024)
#define RQ_CACHE_BASE_ALIGN (512 * 1024)
#endif

#endif /* _RQ_REGS_H_ */
