/*
 * Copyright 2006 Nuova Systems, Inc. All Rights Reserved
 */
#ident "$Id: rq_regs_defs.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _RQ_REGDEFS_H_
#define _RQ_REGDEFS_H_

/*
 * Definitions for the type values that are written to certain register
 */

/*
 * MREG: Type
 * XXX-HW-rq_types: What is the value for the exchange type?
 */
enum rq_mregs_type_types {
    RQ_MREGS_TYPE_ETH = 0,      /* Ethernet/FC frame receive queue type */
    RQ_MREGS_TYPE_FCP = 1,      /* FCP/SCSI Exchange receive queue type */
    RQ_MREGS_TYPE_MAX = 2,      /* Maximum type */
};

/*
 * HREG:  Error Status
 */
enum rq_hregs_error_status_types {
    RQ_HREGS_ERROR_STATUS_NO_ERR = 0,
    RQ_HREGS_ERROR_STATUS_IDX_ERR,
    RQ_HREGS_ERROR_STATUS_DESC_LCL_ADDR_ERR,
    RQ_HREGS_ERROR_STATUS_DESC_ADDR_RSP_ERR,
    RQ_HREGS_ERROR_STATUS_DESC_DATA_RSP_ERR,
    RQ_HREGS_ERROR_STATUS_PKT_LCL_ADDR_ERR,
    RQ_HREGS_ERROR_STATUS_CQ_WR_LCL_ADDR_ERR,
    RQ_HREGS_ERROR_STATUS_CQ_MSG_LCL_ADDR_ERR,
    RQ_HREGS_ERROR_STATUS_PKT_ADDR_RSP_ERR,
    RQ_HREGS_ERROR_STATUS_PKT_DATA_RSP_ERR,
};

#endif /* _RQ_REGDEFS_H_ */
