/*
 * Copyright 2009 Cisco Systems, Inc.  All Rights Reserved.
 */
#ident "$Id: sereno_impl.h 43 2016-12-03 22:59:19Z buildsa $"

#ifndef _SERENO_SERENO_IMPL_H_
#define _SERENO_SERENO_IMPL_H_

/*
 * Constants used in different implementations of PALO.
 */

#define PALO_ASIC_CORE_CLK      156000000       // 156MHz
#define PALO_ASIC_CPU_CLK       670000000       // 670MHz
#define PALO_ASIC_UART_CLK      25000000        // 25MHz
#define PALO_ASIC_NETCORE_CLK   375000000       // 375MHz

#define PALO_FPGA_CPU_CLK       66220000        // 66.22MHz
// The actual UART clock frequency is 4.8MHz,
// but all this value is really used for is to
// determine a divisor value to write into a UART
// register.  Using 4.8 results in a divisor of 7,
// which doesn't work.  Using 5.0 results in 8,
// which works.
#define PALO_FPGA_UART_CLK      5000000         // 5.0MHz
#define PALO_FPGA_NETCORE_CLK   37500000        // 37.5MHz

#define PALO_SIM_CPU_CLK        6000000         // 6MHz
#define PALO_SIM_UART_CLK       5000000         // 5MHz

#endif // _SERENO_SERENO_IMPL_H_
