
/*
------------------------------------------------------------------------
--
--                   (C) COPYRIGHT 2002-2004 SYNOPSYS INC.
--                             ALL RIGHTS RESERVED
--
--  This software and the associated documentation are confidential and
--  proprietary to Synopsys, Inc.  Your use or disclosure of this software
--  is subject to the terms and conditions of a written license agreement
--  between you, or your company, and Synopsys, Inc.
--
--  The entire notice above must be reproduced on all authorized copies.
--
-- File :                       DW_apb_gpio_defs.h
-- Author:                      Frank Kavanagh
-- Version      :               $Revision: 1.3 $
--
--
-- Modification History:
-- Date                 By      Version Change  Description
-- =====================================================================
-- See CVS log
-- =====================================================================
*/

/*
 * Header file for the DW_apb_gpio block.
 */

#ifndef _DW_GPIO_H_
#define _DW_GPIO_H_

#define DW_APB_GPIO_BASE          0x17f00000

#define GPIO_SWPORTA_DR_OFFSET    0x00
#define GPIO_SWPORTA_DDR_OFFSET   0x04
#define GPIO_SWPORTA_CTL_OFFSET   0x08
#define GPIO_SWPORTB_DR_OFFSET    0x0C
#define GPIO_SWPORTB_DDR_OFFSET   0x10
#define GPIO_SWPORTB_CTL_OFFSET   0x14
#define GPIO_SWPORTC_DR_OFFSET    0x18
#define GPIO_SWPORTC_DDR_OFFSET   0x1C
#define GPIO_SWPORTC_CTL_OFFSET   0x20
#define GPIO_SWPORTD_DR_OFFSET    0x24
#define GPIO_SWPORTD_DDR_OFFSET   0x28
#define GPIO_SWPORTD_CTL_OFFSET   0x2C
#define GPIO_INTEN_OFFSET         0x30
#define GPIO_INTMASK_OFFSET       0x34
#define GPIO_INTTYPE_LEVEL_OFFSET 0x38
#define GPIO_INT_POLARITY_OFFSET  0x3C
#define GPIO_INTSTATUS_OFFSET     0x40
#define GPIO_RAW_INTSTATUS_OFFSET 0x44
#define GPIO_DEBOUNCE_OFFSET      0x48
#define GPIO_PORTA_EOI_OFFSET     0x4C
#define GPIO_EXT_PORTA_OFFSET     0x50
#define GPIO_EXT_PORTB_OFFSET     0x54
#define GPIO_EXT_PORTC_OFFSET     0x58
#define GPIO_EXT_PORTD_OFFSET     0x5C
#define GPIO_LS_SYNC_OFFSET       0x60
#define GPIO_ID_CODE_OFFSET       0x64
#define GPIO_REV_ID_CODE_OFFSET   0x68
#define GPIO_VER_ID_CODE_OFFSET   0x6C

#define GPIO_CONFIGID_REG2_OFFSET 0x70

#define GPIO_CONFIGID_REG1_OFFSET 0x74

#define GPIO_VERSION_ID_OFFSET    0x78

#define GPIO_PERIPH_ID_OFFSET     0x7C

#define GPIO_SWPORTA_DR       (DW_APB_GPIO_BASE  + GPIO_SWPORTA_DR_OFFSET)
#define GPIO_SWPORTA_DDR      (DW_APB_GPIO_BASE  + GPIO_SWPORTA_DDR_OFFSET)
#define GPIO_SWPORTA_CTL      (DW_APB_GPIO_BASE  + GPIO_SWPORTA_CTL_OFFSET)
#define GPIO_SWPORTB_DR       (DW_APB_GPIO_BASE  + GPIO_SWPORTB_DR_OFFSET)
#define GPIO_SWPORTB_DDR      (DW_APB_GPIO_BASE  + GPIO_SWPORTB_DDR_OFFSET)
#define GPIO_SWPORTB_CTL      (DW_APB_GPIO_BASE  + GPIO_SWPORTB_CTL_OFFSET)
#define GPIO_SWPORTC_DR       (DW_APB_GPIO_BASE  + GPIO_SWPORTC_DR_OFFSET)
#define GPIO_SWPORTC_DDR      (DW_APB_GPIO_BASE  + GPIO_SWPORTC_DDR_OFFSET)
#define GPIO_SWPORTC_CTL      (DW_APB_GPIO_BASE  + GPIO_SWPORTC_CTL_OFFSET)
#define GPIO_SWPORTD_DR       (DW_APB_GPIO_BASE  + GPIO_SWPORTD_DR_OFFSET)
#define GPIO_SWPORTD_DDR      (DW_APB_GPIO_BASE  + GPIO_SWPORTD_DDR_OFFSET)
#define GPIO_SWPORTD_CTL      (DW_APB_GPIO_BASE  + GPIO_SWPORTD_CTL_OFFSET)
#define GPIO_INTEN            (DW_APB_GPIO_BASE  + GPIO_INTEN_OFFSET)
#define GPIO_INTMASK          (DW_APB_GPIO_BASE  + GPIO_INTMASK_OFFSET)
#define GPIO_INTTYPE_LEVEL    (DW_APB_GPIO_BASE  + GPIO_INTTYPE_LEVEL_OFFSET)
#define GPIO_INT_POLARITY     (DW_APB_GPIO_BASE  + GPIO_INT_POLARITY_OFFSET)
#define GPIO_INTSTATUS        (DW_APB_GPIO_BASE  + GPIO_INTSTATUS_OFFSET)
#define GPIO_RAW_INTSTATUS    (DW_APB_GPIO_BASE  + GPIO_RAW_INTSTATUS_OFFSET)
#define GPIO_DEBOUNCE         (DW_APB_GPIO_BASE  + GPIO_DEBOUNCE_OFFSET)
#define GPIO_PORTA_EOI        (DW_APB_GPIO_BASE  + GPIO_PORTA_EOI_OFFSET)
#define GPIO_EXT_PORTA        (DW_APB_GPIO_BASE  + GPIO_EXT_PORTA_OFFSET)
#define GPIO_EXT_PORTB        (DW_APB_GPIO_BASE  + GPIO_EXT_PORTB_OFFSET)
#define GPIO_EXT_PORTC        (DW_APB_GPIO_BASE  + GPIO_EXT_PORTC_OFFSET)
#define GPIO_EXT_PORTD        (DW_APB_GPIO_BASE  + GPIO_EXT_PORTD_OFFSET)
#define GPIO_LS_SYNC          (DW_APB_GPIO_BASE  + GPIO_LS_SYNC_OFFSET)
#define GPIO_ID_CODE          (DW_APB_GPIO_BASE  + GPIO_ID_CODE_OFFSET)
#define GPIO_REV_ID_CODE      (DW_APB_GPIO_BASE  + GPIO_REV_ID_CODE_OFFSET)
#define GPIO_VER_ID_CODE      (DW_APB_GPIO_BASE  + GPIO_VER_ID_CODE_OFFSET)

#define GPIO_CONFIGID_REG2    (DW_APB_GPIO_BASE  + GPIO_CONFIGID_REG2_OFFSET)

#define GPIO_CONFIGID_REG1    (DW_APB_GPIO_BASE  + GPIO_CONFIGID_REG1_OFFSET)

#define GPIO_VERSION_ID       (DW_APB_GPIO_BASE  + GPIO_VERSION_ID_OFFSET)

#define GPIO_PERIPH_ID        (DW_APB_GPIO_BASE  + GPIO_PERIPH_ID_OFFSET)

#define GPIOPING_1BIT_WR      (GPIO_SWPORTA_DR)

#define CC_GPIO_ADD_ENCODED_PARAM            0x1
#define CC_GPIO_APB_DATA_WIDTH               32
#define CC_GPIO_NUM_PORTS                    4
#define CC_GPIO_ID                           1
#define CC_GPIO_DEBOUNCE                     0
#define CC_GPIO_ID_WIDTH                     32
#define CC_GPIO_ID_NUM                       0x0
#define CC_GPIO_REV_ID                       0
#define CC_GPIO_REV_ID_WIDTH                 32
#define CC_GPIO_REV_ID_NUM                   0x0
#define CC_GPIO_PWIDTH_A                     4
#define CC_GPIO_PORTA_SINGLE_CTL             1
#define CC_GPIO_SWPORTA_RESET                0x0
#define CC_GPIO_HW_PORTA                     1
#define CC_GPIO_DFLT_DIR_A                   0
#define CC_GPIO_DFLT_SRC_A                   0
#define CC_GPIO_PORTA_INTR                   1
#define CC_GPIO_INT_POL                      1
#define CC_GPIO_INTR_IO                      0
#define CC_GPIO_PA_SYNC_EXT_DATA             0
#define CC_GPIO_PA_SYNC_INTERRUPTS           1
#define CC_GPIO_PWIDTH_B                     4
#define CC_GPIO_PORTB_SINGLE_CTL             1
#define CC_GPIO_SWPORTB_RESET                0x0
#define CC_GPIO_HW_PORTB                     1
#define CC_GPIO_DFLT_DIR_B                   0
#define CC_GPIO_DFLT_SRC_B                   0
#define CC_GPIO_PB_SYNC_EXT_DATA             0
#define CC_GPIO_PWIDTH_C                     4
#define CC_GPIO_PORTC_SINGLE_CTL             1
#define CC_GPIO_SWPORTC_RESET                0x0
#define CC_GPIO_HW_PORTC                     1
#define CC_GPIO_DFLT_DIR_C                   0
#define CC_GPIO_DFLT_SRC_C                   0
#define CC_GPIO_PC_SYNC_EXT_DATA             0
#define CC_GPIO_PWIDTH_D                     4
#define CC_GPIO_PORTD_SINGLE_CTL             1
#define CC_GPIO_SWPORTD_RESET                0x0
#define CC_GPIO_HW_PORTD                     1
#define CC_GPIO_DFLT_DIR_D                   0
#define CC_GPIO_DFLT_SRC_D                   0
#define CC_GPIO_PD_SYNC_EXT_DATA             0

#endif

