
/*
 * Copyright (c) 2007 Nuova Systems, Inc.  All rights reserved.
 */
#ident "$Id$"

/*
 * Header file for the DW_apb_wdt block.
 */
#ifndef _DW_WDT_H_
#define _DW_WDT_H_

#define DW_APB_WDT_BASE             0x17f60000
#define DW_APB_WDT_STRIDE           0x10000

#define DW_WDT_CR_OFFSET            0x00
#define DW_WDT_TORR_OFFSET          0x04
#define DW_WDT_CCVR_OFFSET          0x08
#define DW_WDT_CRR_OFFSET           0x0c
#define DW_WDT_STAT_OFFSET          0x10
#define DW_WDT_EOI_OFFSET           0x14
#define DW_WDT_VID_OFFSET           0x18

#define DW_WDT_REG(d, r)            (DW_APB_WDT_BASE + \
                                    (d) * DW_APB_WDT_STRIDE + \
                                    DW_WDT_##r##_OFFSET)

#define DW_WDT_CR(d)                DW_WDT_REG(d, CR)
#define DW_WDT_TORR(d)              DW_WDT_REG(d, TORR)
#define DW_WDT_CCVR(d)              DW_WDT_REG(d, CCVR)
#define DW_WDT_CRR(d)               DW_WDT_REG(d, CRR)
#define DW_WDT_STAT(d)              DW_WDT_REG(d, STAT)
#define DW_WDT_EOI(d)               DW_WDT_REG(d, EOI)
#define DW_WDT_VID(d)               DW_WDT_REG(d, VID)

#define DW_WDT_CR_RPL_SHIFT         2
#define DW_WDT_CR_RPL_MASK          0x7
#define DW_WDT_CR_RMOD              (1 << 1)
#define DW_WDT_CR_WDT_EN            (1 << 0)

#define DW_WDT_TORR_TOP_INIT_SHIFT  4
#define DW_WDT_TORR_TOP_INIT_MASK   0xf
#define DW_WDT_TORR_TOP_SHIFT       0
#define DW_WDT_TORR_TOP_MASK        0xf

#define DW_WDT_CRR_MAGIC            0x76


#define DW_CC_WDT_TORR_WIDTH        4
#define DW_CC_WDT_CNT_RST           0xffff
#define DW_CC_WDT_VERSION_ID        0x3130332a

#endif

