/*
 * Copyright 2006 Nuova Systems, Inc.  All Rights Reserved.
 * Copyright 2009 Cisco Systems, Inc.  All Rights Reserved.
 */
#ident "$Id: wq_regs.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _WQ_REGS_H_
#define _WQ_REGS_H_

#include "wq_hregs.h"
#include "wq_mregs.h"
#include "wq_dregs.h"
#include "wq_mregs_gbl.h"
#include "wq_mregs_sched.h"
#include "wq_regs_defs.h"

#undef WQ_HREGS_BLKSZ
#define WQ_HREGS_BASE   WQ_HREGS_RING_BASE
#define WQ_HREGS_MAXCNT WQ_HREGS_RING_BASE_MAXCNT
#define WQ_HREGS_BLKSZ  WQ_HREGS_RING_BASE_BLKSZ

#undef WQ_MREGS_BLKSZ
#define WQ_MREGS_BASE   WQ_MREGS_WQ_TYPE
#define WQ_MREGS_MAXCNT WQ_MREGS_WQ_TYPE_MAXCNT
#define WQ_MREGS_BLKSZ  WQ_MREGS_WQ_TYPE_BLKSZ

#define WQ_HREGS_OFFSET(reg) \
  (WQ_HREGS_##reg##_OFFSET - WQ_HREGS_RING_BASE_OFFSET)
#define WQ_MREGS_OFFSET(reg) \
  (WQ_MREGS_##reg##_OFFSET - WQ_MREGS_WQ_TYPE_OFFSET)

#ifdef CONFIG_BASE_PALO
#include "wq_mregs_vnic.h"

#define WQ_MREGS_VNIC_BASE__    WQ_MREGS_VNIC_LOCAL_DMA_BASE
#define WQ_MREGS_VNIC_MAXCNT__  WQ_MREGS_VNIC_LOCAL_DMA_BASE_MAXCNT
#define WQ_MREGS_VNIC_BLKSZ__   WQ_MREGS_VNIC_LOCAL_DMA_BASE_BLKSZ

#define WQ_MREGS_VNIC_OFFSET_GEN(reg) \
  (WQ_MREGS_VNIC_##reg##_OFFSET - WQ_MREGS_VNIC_LOCAL_DMA_BASE_OFFSET)

#define WQ_CACHE_BASE_SIZE  (512 * 1024)
#define WQ_CACHE_BASE_ALIGN (512 * 1024)
#endif

#endif /* _WQ_REGS_H_ */
