/*
 * Copyright 2006 Nuova Systems, Inc. All Rights Reserved
 */
#ident "$Id: wq_regs_defs.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _WQ_REGDEFS_H_
#define _WQ_REGDEFS_H_

/*
 * Definitions for the type values that are written to certain register
 */

/*
 * MREG: Type
 */
enum wq_mregs_type_types {
    WQ_MREGS_TYPE_ETH = 0,      /* Ethernet/FC frame work queue type */
    WQ_MREGS_TYPE_COPY = 1,     /* Descriptor copy work queue type */
    WQ_MREGS_TYPE_EXCH = 2,     /* FC/SCSI Exchange work queue type */
    WQ_MREGS_TYPE_MAX = 3,      /* Maximum type */
};

/*
 * MREG: Desc Size
 */
enum wq_mregs_desc_size_types {
    WQ_MREGS_DESC_SIZE_16 = 0,  /* Copy 16 byte descriptors */
    WQ_MREGS_DESC_SIZE_32 = 1,  /* Copy 32 byte descriptors */
    WQ_MREGS_DESC_SIZE_64 = 2,  /* Copy 64 byte descriptors */
    WQ_MREGS_DESC_SIZE_128 = 3, /* Copy 128 byte descriptors */
};

/*
 * MREG: Egress Port
 */
#define WQ_MREGS_EGRESS_PORT_EC_OVERRIDE        (1UL << 3)
#define WQ_MREGS_EGRESS_PORT_EC_OVERRIDE_SHIFT  3
#define WQ_MREGS_EGRESS_PORT_EC_SELECT_MASK     0x3
#define WQ_MREGS_EGRESS_PORT_EC_SELECT_SHIFT    0x1

/*
 * HREG:  Error Status
 */
enum wq_hregs_error_status_types {
    WQ_HREGS_ERROR_STATUS_NO_ERR = 0,
    WQ_HREGS_ERROR_STATUS_IDX_ERR,
    WQ_HREGS_ERROR_STATUS_DESC_LCL_ADDR_ERR,
    WQ_HREGS_ERROR_STATUS_DESC_ADDR_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_DESC_DATA_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_PKT_LCL_ADDR_ERR,
    WQ_HREGS_ERROR_STATUS_CQ_WR_LCL_ADDR_ERR,
    WQ_HREGS_ERROR_STATUS_CQ_MSG_LCL_ADDR_ERR,
    WQ_HREGS_ERROR_STATUS_PKT_ADDR_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_PKT_DATA_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_PKT_SIZE_ERR,
    WQ_HREGS_ERROR_STATUS_PKT_TSO_LEN_ERR,
    WQ_HREGS_ERROR_STATUS_PKT_MSS_ZERO_ERR,
    WQ_HREGS_ERROR_STATUS_EOP_NOT_FOUND_ERR,
    WQ_HREGS_ERROR_STATUS_VER_ERR,
    WQ_HREGS_ERROR_STATUS_RSVD_0,
    WQ_HREGS_ERROR_STATUS_FC_SGL_TOO_SMALL_ERR,
    WQ_HREGS_ERROR_STATUS_FC_MSS_ZERO_ERR,
    WQ_HREGS_ERROR_STATUS_FC_SGL_LEN_ZERO_ERR,
    WQ_HREGS_ERROR_STATUS_FC_SGL_OFFSET_ERR,
    WQ_HREGS_ERROR_STATUS_FC_SGL_CNT_ZERO_ERR,
    WQ_HREGS_ERROR_STATUS_FC_XID_INVALID_ERR,
    WQ_HREGS_ERROR_STATUS_FC_XTBL_PM_ADDR_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_FC_XTBL_PM_DATA_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_FC_XTBL_SS_ADDR_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_FC_XTBL_SS_DATA_RSP_ERR,
    WQ_HREGS_ERROR_STATUS_FC_BURST_OFF_ERR,
    WQ_HREGS_ERROR_STATUS_FC_REL_OFF_ERR,
    WQ_HREGS_ERROR_STATUS_FC_XTBL_ACCESS_ERR,
    WQ_HREGS_ERROR_STATUS_FC_SGL_CNT_MAX_ERR,
    WQ_HREGS_ERROR_STATUS_FC_SGLERR_NONZERO_ERR,
    WQ_HREGS_ERROR_STATUS_RSVD_1,
};

#define WQ_ERROR_STATUS_INTR_MAX_OFFSET     128

#endif /* _WQ_REGDEFS_H_ */
